program UMnuDmo;

var
  MyMainMenu: TMainMenu;
  MyPopUpMenu: TPopUpMenu;
  MySubItem1,MySubItem2 : TMenuItem;
  MySubItems: array[0..3] of TMenuItem;
  MyPopUpItems: array[0..3] of TMenuItem;

procedure MyPopupHandler(Sender: TObject);
begin
  with TMenuItem(Sender) do begin
    ShowMessage(Caption);
  end;
end;

procedure Button1_OnClick(Sender: TObject);
begin
  MyMainMenu:= TMainMenu.Create(Self);
  Button4.Enabled := true;
  ShowMessage('MainMenu created but no items' + #13+
              'are added so it does not show.');
  Button1.Enabled := False;
end;

procedure Button2_OnClick(Sender: TObject);
begin
  MyPopUpMenu := TPopUpMenu.Create(self);
  Button3.Enabled := true;
  ShowMessage('PopUpMenu created.');
  Button2.Enabled := False;
end;

procedure Button7_OnClick(Sender: TObject);
begin
  MyPopUpMenu.Popup(Self.Left + 60, Self.Top + 140);
  Button9.Enabled := true;
end;

procedure Button3_OnClick(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to 3 do begin
    MyPopUpItems[i] := TMenuItem.Create(Self);
    MyPopUpItems[i].Caption := 'New item ' + IntToStr(i);
    MyPopUpMenu.Items.Add(MyPopUpItems[i]);
  end;
  Button7.Enabled := true;
  Button3.Enabled := False;
end;

procedure Button4_OnClick(Sender: TObject);
var
  MyItem: array[0..2] of TMenuItem;
  i: Integer;
begin
  for i := 0 to 2 do begin
    MyItem[i] := TMenuItem.Create(Self);
    MyItem[i].Caption := 'New item ' + IntToStr(i);
    MyMainMenu.Items.Add(MyItem[i]);
    end;
  Button4.Enabled := False;
  Button5.Enabled := true;
end;

procedure Button5_OnClick(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to 3 do begin
    MySubItems[i] := TMenuItem.Create(Self);
    MySubItems[i].Caption := 'New item ' + IntToStr(i);
    MySubItems[i].OnClick := @MyPopUpHandler;
    MyMainMenu.Items.Items[0].Add(MySubItems[i]);
  end;
  Button8.Enabled := true;
  Button5.Enabled := False;
end;

procedure Button8_OnClick(Sender: TObject);
begin
  MySubItems[2].Caption :='-';
end;

procedure Button9_OnClick(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to 3 do begin
    MyPopUpItems[i].OnClick := @MyPopupHandler;
  end;
end;

procedure AssignEvents;
begin
  Button1.OnClick := @Button1_OnClick;
  Button3.OnClick := @Button3_OnClick;
  Button2.OnClick := @Button2_OnClick;
  Button4.OnClick := @Button4_OnClick;  
  Button5.OnClick := @Button5_OnClick;
  Button7.OnClick := @Button7_OnClick;
  Button8.OnClick := @Button8_OnClick;
  Button9.OnClick := @Button9_OnClick;
end;

begin
  AssignEvents;
end.